/* This is a touch sensing library.  If you don't have any buttons lying around but need
 * user input, you may still have what you need.  A few capacitors, resistors, unused pins,
 * and some wire and you've got yourself some capacitive input.
 *
 * This library (theBadTouch) by Aaron Goselin.  You are free to do what you like with this,
 * but please keep credit in place.
 * 2010 Aaron Goselin.
 *
 */

#ifndef _TOUCHYMCTOUCHERTON_
#define _TOUCHYMCTOUCHERTON_

#include "mbed.h"


class theBadTouch {

public:


    theBadTouch(PinName touchPin, PinName sink);
    

    float badPlace();
    char isTouch();

protected:
    DigitalIn * _sink;
    DigitalInOut * _precharge;
    AnalogIn * _sense;
    PinName _sensor;
    bool tracker1, tracker2;
    Timer t, t_off;
    char _touchFlag, _untouchedFlag;
    int falseCounter;
    char _touchCounter;
    

    
};

#endif